#include <iostream>
#include <math.h>
#include <iomanip>
#define eps 1e-9
using namespace std;

struct Parabola
{
       double a, b, c;
       Parabola(double _a, double _b, double _c)
        :a(_a), b(_b), c(_c){}
       double pickX() { return -b/(2*a); }
       double pickY() { return a*pickX()*pickX() + b*pickX() + c; }
       double x1() { return (-b+sqrt(b*b - 4*a*c))/(2*a); }
       double x2() { return (-b-sqrt(b*b - 4*a*c))/(2*a); }
       double y(double x)
       {
              return a*x*x + b*x + c;
       }
       void moveright(double k)
       {
            c += a*k*k - b*k;
            b -= 2*a*k;
       }
       bool fixAt(double x, double y)
       {
            Parabola temp = *this;
            temp.c -= y;
            if (temp.b*temp.b - 4*temp.a*temp.c < 0 - eps) return 0;
            moveright(x - temp.x1()); 
            return 1;
       }
};

int px[2500], py[2500], N;

bool check(Parabola &p)
{
     for (int i = 0; i < N; i++)
     {
         double y1 = p.y(px[i]);
         double y2 = py[i];
         if (y1 < y2 - eps) return 0;
     }
     return 1;
} 
int main()
{
    double A, B, C;
    cin >> A >> B >> C;
    Parabola p(A, B, 0);
    //cout << p.x1() << " " << p.x2() << " " << p.pickX() << " " << p.pickY()  << endl;
    cin >> N;
    for (int i = 0; i < N; i++) cin >> px[i] >> py[i];
    cout << setiosflags(ios::fixed) << setprecision(8);
    double l = 0, r = 1e5, lastx = -1;
    for (int qqq = 0; qqq < 25; qqq++)
    {
        Parabola temp = p;
        double m = (l+r)/2;
        //cout << m << endl;
        temp.c = m + (temp.b*temp.b)/(4*temp.a);
        //cout << temp.a << " " << temp.b << " " << temp.c << endl;
        //return 0;
        
        bool flag = 0;
        for (int i = 0; i < N; i++) 
        {
            Parabola temp2 = temp;
            if (temp2.fixAt(px[i], py[i]) == 0) continue; 
            //cout <<
            // temp2.x1() << " " << temp2.x2() << " "  
            // << temp2.pickX() << " " << temp2.pickY() << endl;
            if (check(temp2)) { flag = 1; lastx = -temp2.b/(2*temp2.a); break; }
        }
        
        if (flag) r = m;
        else l = m;
    }
    //cout << check(lastx, r) << endl;
    cout << lastx << " " << r << endl;
    return 0;
}
