
#include <map>
#include <iostream>
using namespace std;

const int MAXN = 2505;
const double EPS = 1e-6;

int N;
double A, B, C;
double x[MAXN], y[MAXN];

void read() {
    cin >> A >> B >> C;
    cin >> N;
    int K = 0;
    map <int, int> all;
    for (int i = 0; i < N; ++i) {
        int X, Y;
        scanf("%d %d", &X, &Y);
        if (all.count(X))
            all[X] = max(all[X], Y);
        else
            all[X] = Y;
    }
    for (typeof(all.begin()) it = all.begin(); it != all.end(); ++it) {
        x[K] = it->first;
        y[K] = it->second;
        ++K;
    }
    N = K;
}

inline double eval(double dx, double dy, bool show = false) {
    double X = -B / (2 * A);
    double Y = A * X * X + B * X + C;
    if (show) {
        //cout << X + dx << " " << Y + dy << endl;
        printf("%.10lf %.10lf\n", X + dx, Y + dy);
    }
//    cout << "at position " << X << ", " << Y << endl;
    double res = 1e100;
    for (int i = 0; i < N; ++i) {
        double x1 = x[i] - dx;
        double y1 = y[i] - dy;
        double R = A * x1 * x1 + B * x1 + C;
        res = min(res, R - y1);
    }
//    if (show)
//        printf("%.10lf\n", res);
    return res;
}

inline double search(double dy) {
    double l = -1000000000.0;
    double r = +1000000000.0;
    while (r - l > EPS) {
//    for (int i = 0; i < 1000; ++i) {
        double m1 = (l + l + r) / 3;
        double m2 = (l + r + r) / 3;
        
        //double m = (l + r) / 2;
        //if (eval(m, dy) < eval(m + 1e-9, dy))
        //    l = m;
        //else
        //    r = m;
        
        if (eval(m1, dy) < eval(m2, dy))
            l = m1;
        else
            r = m2;
    }
    return (l + r) / 2;
}

void solve() {
    // Fix delta y!
    double l = -1000000000.0;
    double r = +1000000000.0; 
    
    while (r - l > EPS) {
        double m = (l + r) / 2;
        double x = search(m);
        if (eval(x, m) > EPS)
            r = m;
        else
            l = m;
    }
    double dy = (l + r) / 2;
    double dx = search(dy);
    eval(dx, dy, true);
}

int main() {
    read();
//    double X = -B / (2 * A);
//    double Y = A * X * X + B * X + C;
//    cout << eval(0, 0) << endl;
//    cout << eval(-2, -43) << endl;
//    for (double x = -10.0; x < 10.0; x += 1.0)
//        cout << x << " " << A * x * x + B * x + C << endl;
//    cout << X << " " << Y << endl;
//    return 0;
    solve();
    return 0;
}
