#include <cmath>
#include <cstdio>
#include <algorithm>
using namespace std;

const int MAXN = 1 << 12;

struct point {
    double x , y;
    
    void read() {
        scanf ( "%lf%lf" , &x , &y );
    }
};

int n;
double a , b , c;
point f[MAXN];

void read() {
    int i;
    
    scanf ( "%lf%lf%lf" , &a , &b , &c );
    scanf ( "%d" , &n );
    for (i = 1; i <= n; i++) 
        f[i].read();
}

int cmp ( point a , point b ) {
    return a.x < b.y;
}

int under ( point f , double y , double x ) {
    double we = - b / (2 * a) - x + f.x;
    double delta = y - ((b * b) / (4 * a)) + (b * b) / (2 * a);
    double now = a * we * we + b * we;

    return (f.y - (delta + now)) < 0;
}

void solve() {
    int iter1 , iter2;
    double l1 , r1 , l2 , r2;
    double mid1 , mid2;
    int i;
    int can;
    
    l1 = 0.;
    r1 = 1e4;
    
    sort ( f + 1 , f + n + 1 , cmp );
    
    for (iter1 = 100; iter1 --; ) {
        can = 0;
        mid1 = (l1 + r1) / 2.;
        
        l2 = 0;
        r2 = 50;
        
        for (iter2 = 100; iter2 --; ) {
            mid2 = (l2 + r2) / 2.;

            for (i = 1; i <= n; i++) 
                if ( !under ( f[i] , mid1 , mid2 ) )
                    break;
                    
            if ( i > n ) {
                can = 1;
                break;
            }
                    
            if ( f[i].x > mid2 )
                l2 = mid2;
            else
                r2 = mid2;
        }
        
        if ( can )
            r1 = mid1;
        else
            l1 = mid1;
    }
    
    printf ( "%.16lf %.16lf\n" , mid2 , mid1 + 1e-15 );
}

int main() {
    read();
    solve();
    
    return 0;
}
